# Creating HTML-page of server links
# This bot script hourly creates log file of server links
# Wiking 1998 <wiking@uniyar.ac.ru>
# For eggdrop1.3.x
# v 1.3
# Email me if this script has appeared useful or has bugs
# Test url: http://www.uniyar.ac.ru/~wiking/Irc/links.htm 

# Briefing:
# Program creates HTML page with tree of server links and some link info).
# For correct work it is necessary to set all variables in both scripts.
# Features:
# 1) Program included two scripts: perl and tcl
# 2) It can work as CGI script, creating dynamic HTML file, or both together
# 3) If used as CGI script it is necessary to locate logfile in the directory
#    allowed to read by all
# 4) Additional possibilities is only in the CGI script variant
# 5) Current configuration is both for CGI and for dynamic file creation
# 6) Perl script used as cgi-script, also it is executed by bot if dynamic file 
#    creation mode selected
# 7) It is preferably to locate tcl-script in the  bot script directory
#    and pl-script in the httpd cgi-bin directory
#
# P.S. script developed under UNIX, also it tested under Windows. 
# For Windows you need correct two procedures in this script. And 
# install Perl compiler of course.
#

# Bot logfile location (must be public readable if CGI used)
set w3_bot_log "/somewhere/links.log"

# Perl script location (must be public executable if CGI used)
set w3_script "/somewhere/zw3links.pl"

# Updating rate in minutes
set w3_upd_rate 60

# The same when split
set w3_upd_rate2 10

# Set it to 1 if you use program as cgi-script 
# if cgi+dynamic or dynamic file creation variant set it to 0
set w3_only_cgi 0

# Correct below if you have Windows. Replace mv and rm as needed.
proc w3l_mv { f1 f2 } {
  catch { exec mv $f1 $f2 }
  }

proc w3l_del { f } {
  catch { exec rm -f $f }
  }

set env(ZW3) ZW3
proc w3l_do { f } {
  set env(ZW3) ZW3
  catch { exec $f }
  }
 

##########################################################33
if { ![info exist w3_all] } { set w3_all 0 }

bind raw - 364 w3_c_links
bind raw - 365 w3_c_links
proc w3_c_links { from key arg } {
  global w3_done w3_all w3_upd_rate w3_upd_rate2 w3_bot_log w3_script w3_only_cgi
  switch $key {
    364 { 
      set f [open ${w3_bot_log}_ a] 
      puts $f "$from $key $arg"
      close $f
      incr w3_all
      } 
    365 {
      set f [open ${w3_bot_log}_ a] 
      puts $f "Current: [ctime [unixtime]]"
      if { $w3_all > 5 } { set d $w3_upd_rate } { set d $w3_upd_rate2 }
      puts $f "Next: [ctime [expr [unixtime] + 60*$d]]"
      close $f
      w3l_mv ${w3_bot_log}_ $w3_bot_log
      if { !$w3_only_cgi } {
        w3l_do $w3_script
	}
      }
    }
  }


proc w3_u_links {} {
  global w3_upd_rate w3_done w3_all w3_upd_rate2 w3_timer w3_bot_log
  w3l_del ${w3_bot_log}_
  putserv "LINKS"
  catch { if { [info exist w3_timer] } { killtimer $w3_timer } }
  if { $w3_all > 5 } { set d $w3_upd_rate } { set d $w3_upd_rate2 }
  set w3_timer [timer $d w3_u_links]
  set w3_all 0
  }


if { ![string match "* w3_u_links *" [timers]] } { w3_u_links }
putlog "ZW3LINKS-1.2 by Wiking 1998 loaded"
